//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3A7EC53B01BF.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3A7EC53B01BF.cm

//## begin module%3A7EC53B01BF.cp preserve=no
//## end module%3A7EC53B01BF.cp

//## Module: FitMethod%3A7EC53B01BF; Package specification
//## Subsystem: XSFit::Fit%3677C9158350
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/Fit/FitMethod.h

#ifndef FITSTAT_H
#define FITSTAT_H 1

//## begin module%3A7EC53B01BF.additionalIncludes preserve=no
//## end module%3A7EC53B01BF.additionalIncludes

//## begin module%3A7EC53B01BF.includes preserve=yes
//## end module%3A7EC53B01BF.includes

// xsTypes
#include <main/xsTypes.h>
// string
#include <string>
// map
#include <map>
// Error
#include <XSUtil/Error/Error.h>
// FitStrategy
#include <XSFit/Fit/FitStrategy.h>
//## begin module%3A7EC53B01BF.declarations preserve=no
//## end module%3A7EC53B01BF.declarations

//## begin module%3A7EC53B01BF.additionalDeclarations preserve=yes
#include <set>
//## end module%3A7EC53B01BF.additionalDeclarations


//## begin FitMethod%3A7EC4580119.preface preserve=yes
//## end FitMethod%3A7EC4580119.preface

//## Class: FitMethod%3A7EC4580119
//## Category: XSFit::Fit%36349D710188
//## Subsystem: XSFit::Fit%3677C9158350
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3B7BE6A3030E;std::map { -> }
//## Uses: <unnamed>%3B7BF00F01C3;std::string { -> }

class FitMethod : public FitStrategy  //## Inherits: <unnamed>%3A7EC4820169
{
  //## begin FitMethod%3A7EC4580119.initialDeclarations preserve=yes
  //## end FitMethod%3A7EC4580119.initialDeclarations

  public:
    //## Class: FitError%3C8794380130
    //## Category: XSFit::Fit%36349D710188
    //## Subsystem: XSFit::Fit%3677C9158350
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class FitError : public YellowAlert  //## Inherits: <unnamed>%3C8795A0026A
    {
      public:
        //## Constructors (specified)
          //## Operation: FitError%3C87944B0256
          FitError (int errCode, int paramNumber = 0);

      protected:
      private:
      private: //## implementation
    };

    //## Destructor (generated)
      virtual ~FitMethod();

    //## Assignment Operation (generated)
      FitMethod & operator=(const FitMethod &right);


    //## Other Operations (specified)
      //## Operation: get%3B7AC1E8024A
      static FitMethod* get (const std::string& name);

      //## Operation: registerMethod%3BFABD5201B5
      static void registerMethod (const string& name, FitMethod* method);

      //## Operation: processMethodString%3C1A705401EB
      void processMethodString (const IntegerArray& iParams, const StringArray& params);

      //## Operation: fitNames%3C83B98D03D1
      static string fitNames ();

      //## Operation: clone%3C84DBB10074
      virtual FitMethod* clone () const = 0;

      //## Operation: reportProgress%3C8E315A0318
      virtual void reportProgress (std::ostream& s, Fit* fit) const;

      //## Operation: perform%3D52950E0187
      void perform (Fit* fit);

      //## Operation: evalue%3F1C287F0321
      const RealArray& evalue () const;

      //## Operation: evector%3F1C28BC013E
      const RealArray& evector () const;

      //## Operation: settingString%3F3CE5BC0256
      virtual string settingString () const = 0;

      //## Operation: fullName%3FCE0BDB0242
      virtual string fullName () const = 0;

      //## Operation: getErrors%41A36E320295
      virtual bool getErrors (Fit* fit, const string& modelName, const IntegerArray& paramNums);

      //## Operation: covariance%41A3B94803E2
      const RealArray& covariance () const;

      //## Operation: reportCovariance%41A3B98502D7
      void reportCovariance () const;

      //## Operation: clearMethods%429F4E8201E9
      static void clearMethods ();

      //## Operation: processMethodStringExtras%4342BB9C02C2
      virtual void processMethodStringExtras (const IntegerArray& iParams, const StringArray& params);

      //## Operation: improve%467A96B402BC
      virtual void improve (Fit* fit);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: secondDerivativeRequired%3B7A988B01BD
      bool secondDerivativeRequired () const;

      //## Attribute: firstDerivativeRequired%3B7AD4850030
      bool firstDerivativeRequired () const;

      //## Attribute: deltaCrit%3D4802240080
      Real deltaCrit () const;
      void deltaCrit (Real value);

      //## Attribute: numberOfTrials%3D48023D0300
      int numberOfTrials () const;
      void numberOfTrials (int value);

      //## Attribute: selectedSubMethod%467A926C0213
      const string& selectedSubMethod () const;

    //## Get and Set Operations for Associations (generated)

      //## Association: XSFit::Fit::<unnamed>%3F1C256903A4
      //## Role: FitMethod::evalue%3F1C256D0386
      RealArray& evalue ();
      void setEvalue (const RealArray& value);

      //## Association: XSFit::Fit::<unnamed>%3F1C26840016
      //## Role: FitMethod::evector%3F1C2686011D
      RealArray& evector ();
      void setEvector (const RealArray& value);

      //## Association: XSFit::Fit::<unnamed>%41A3B83D023A
      //## Role: FitMethod::covariance%41A3B8400121
      RealArray& covariance ();
      void setCovariance (const RealArray& value);

  public:
    // Additional Public Declarations
      //## begin FitMethod%3A7EC4580119.public preserve=yes
      //## end FitMethod%3A7EC4580119.public

  protected:
    //## Constructors (generated)
      FitMethod(const FitMethod &right);

    //## Constructors (specified)
      //## Operation: FitMethod%3A7EC4A60306
      FitMethod (const std::string& initString);


    //## Other Operations (specified)
      //## Operation: secondDerivativeRequired%3B7AE1F40000
      void secondDerivativeRequired (bool value);

      //## Operation: firstDerivativeRequired%3B7AE22101D4
      void firstDerivativeRequired (bool value);

      //## Operation: swap%3C84F0EC0131
      virtual void swap (FitMethod& right);

      //## Operation: selectedSubMethod%467C25980363
      void selectedSubMethod (const string& subMethod);

    // Additional Protected Declarations
      //## begin FitMethod%3A7EC4580119.protected preserve=yes
      //## end FitMethod%3A7EC4580119.protected

  private:

    //## Other Operations (specified)
      //## Operation: copy%3C84DC040177
      virtual void copy (const FitMethod& right) = 0;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: pegsParameters%3B7AC4A301B9
      const bool pegsParameters () const;
      void pegsParameters (bool value);

    // Additional Private Declarations
      //## begin FitMethod%3A7EC4580119.private preserve=yes
      //## end FitMethod%3A7EC4580119.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin FitMethod::secondDerivativeRequired%3B7A988B01BD.attr preserve=no  public: bool {U} 
      bool m_secondDerivativeRequired;
      //## end FitMethod::secondDerivativeRequired%3B7A988B01BD.attr

      //## begin FitMethod::pegsParameters%3B7AC4A301B9.attr preserve=no  private: bool {U} 
      bool m_pegsParameters;
      //## end FitMethod::pegsParameters%3B7AC4A301B9.attr

      //## begin FitMethod::firstDerivativeRequired%3B7AD4850030.attr preserve=no  public: bool {U} 
      bool m_firstDerivativeRequired;
      //## end FitMethod::firstDerivativeRequired%3B7AD4850030.attr

      //## begin FitMethod::deltaCrit%3D4802240080.attr preserve=no  public: Real {U} 
      Real m_deltaCrit;
      //## end FitMethod::deltaCrit%3D4802240080.attr

      //## begin FitMethod::numberOfTrials%3D48023D0300.attr preserve=no  public: int {U} 
      int m_numberOfTrials;
      //## end FitMethod::numberOfTrials%3D48023D0300.attr

      //## begin FitMethod::selectedSubMethod%467A926C0213.attr preserve=no  public: string {U} 
      string m_selectedSubMethod;
      //## end FitMethod::selectedSubMethod%467A926C0213.attr

      //## Attribute: fitMethodObjs%467A93590309
      //	This container will own all FitMethod object prototypes.
      //## begin FitMethod::fitMethodObjs%467A93590309.attr preserve=no  private: static std::set<FitMethod*> {U} 
      static std::set<FitMethod*> s_fitMethodObjs;
      //## end FitMethod::fitMethodObjs%467A93590309.attr

      //## Attribute: subMethods%467A93E903A1
      //	String keys refer to the names users may enter with the
      //	method command.  Multiple name keys may refer to the
      //	same FitMethod* since FitMethod can be a general package
      //	containing many "sub" methods (ie. Minuit). For this
      //	reason, delete should never be called on pointers from
      //	this map.  s_fitMethodObjs contains single copies of
      //	these pointers and therefore should handle deletions.
      //## begin FitMethod::subMethods%467A93E903A1.attr preserve=no  private: static std::map<string,FitMethod*> {U} 
      static std::map<string,FitMethod*> s_subMethods;
      //## end FitMethod::subMethods%467A93E903A1.attr

    // Data Members for Associations

      //## Association: XSFit::Fit::<unnamed>%3F1C256903A4
      //## begin FitMethod::evalue%3F1C256D0386.role preserve=no  public: RealArray { -> 1VHgN}
      RealArray m_evalue;
      //## end FitMethod::evalue%3F1C256D0386.role

      //## Association: XSFit::Fit::<unnamed>%3F1C26840016
      //## begin FitMethod::evector%3F1C2686011D.role preserve=no  public: RealArray { -> 1VHgN}
      RealArray m_evector;
      //## end FitMethod::evector%3F1C2686011D.role

      //## Association: XSFit::Fit::<unnamed>%41A3B83D023A
      //## begin FitMethod::covariance%41A3B8400121.role preserve=no  public: RealArray { -> 1VHgN}
      RealArray m_covariance;
      //## end FitMethod::covariance%41A3B8400121.role

    // Additional Implementation Declarations
      //## begin FitMethod%3A7EC4580119.implementation preserve=yes
      //## end FitMethod%3A7EC4580119.implementation

};

//## begin FitMethod%3A7EC4580119.postscript preserve=yes
//## end FitMethod%3A7EC4580119.postscript

// Class FitMethod::FitError 

// Class FitMethod 


//## Other Operations (inline)
inline void FitMethod::selectedSubMethod (const string& subMethod)
{
  //## begin FitMethod::selectedSubMethod%467C25980363.body preserve=yes
  m_selectedSubMethod = subMethod;
  //## end FitMethod::selectedSubMethod%467C25980363.body
}

//## Get and Set Operations for Class Attributes (inline)

inline bool FitMethod::secondDerivativeRequired () const
{
  //## begin FitMethod::secondDerivativeRequired%3B7A988B01BD.get preserve=no
  return m_secondDerivativeRequired;
  //## end FitMethod::secondDerivativeRequired%3B7A988B01BD.get
}

inline const bool FitMethod::pegsParameters () const
{
  //## begin FitMethod::pegsParameters%3B7AC4A301B9.get preserve=no
  return m_pegsParameters;
  //## end FitMethod::pegsParameters%3B7AC4A301B9.get
}

inline void FitMethod::pegsParameters (bool value)
{
  //## begin FitMethod::pegsParameters%3B7AC4A301B9.set preserve=no
  m_pegsParameters = value;
  //## end FitMethod::pegsParameters%3B7AC4A301B9.set
}

inline bool FitMethod::firstDerivativeRequired () const
{
  //## begin FitMethod::firstDerivativeRequired%3B7AD4850030.get preserve=no
  return m_firstDerivativeRequired;
  //## end FitMethod::firstDerivativeRequired%3B7AD4850030.get
}

inline Real FitMethod::deltaCrit () const
{
  //## begin FitMethod::deltaCrit%3D4802240080.get preserve=no
  return m_deltaCrit;
  //## end FitMethod::deltaCrit%3D4802240080.get
}

inline void FitMethod::deltaCrit (Real value)
{
  //## begin FitMethod::deltaCrit%3D4802240080.set preserve=no
  m_deltaCrit = value;
  //## end FitMethod::deltaCrit%3D4802240080.set
}

inline int FitMethod::numberOfTrials () const
{
  //## begin FitMethod::numberOfTrials%3D48023D0300.get preserve=no
  return m_numberOfTrials;
  //## end FitMethod::numberOfTrials%3D48023D0300.get
}

inline void FitMethod::numberOfTrials (int value)
{
  //## begin FitMethod::numberOfTrials%3D48023D0300.set preserve=no
  m_numberOfTrials = value;
  //## end FitMethod::numberOfTrials%3D48023D0300.set
}

inline const string& FitMethod::selectedSubMethod () const
{
  //## begin FitMethod::selectedSubMethod%467A926C0213.get preserve=no
  return m_selectedSubMethod;
  //## end FitMethod::selectedSubMethod%467A926C0213.get
}

//## Get and Set Operations for Associations (inline)

inline RealArray& FitMethod::evalue ()
{
  //## begin FitMethod::evalue%3F1C256D0386.get preserve=no
  return m_evalue;
  //## end FitMethod::evalue%3F1C256D0386.get
}

inline void FitMethod::setEvalue (const RealArray& value)
{
  //## begin FitMethod::setEvalue%3F1C256D0386.set preserve=yes
  m_evalue.resize(value.size());
  m_evalue = value;
  //## end FitMethod::setEvalue%3F1C256D0386.set
}

inline RealArray& FitMethod::evector ()
{
  //## begin FitMethod::evector%3F1C2686011D.get preserve=no
  return m_evector;
  //## end FitMethod::evector%3F1C2686011D.get
}

inline void FitMethod::setEvector (const RealArray& value)
{
  //## begin FitMethod::setEvector%3F1C2686011D.set preserve=yes
  m_evector.resize(value.size());
  m_evector = value;
  //## end FitMethod::setEvector%3F1C2686011D.set
}

inline RealArray& FitMethod::covariance ()
{
  //## begin FitMethod::covariance%41A3B8400121.get preserve=no
  return m_covariance;
  //## end FitMethod::covariance%41A3B8400121.get
}

inline void FitMethod::setCovariance (const RealArray& value)
{
  //## begin FitMethod::setCovariance%41A3B8400121.set preserve=no
  m_covariance = value;
  //## end FitMethod::setCovariance%41A3B8400121.set
}

//## begin module%3A7EC53B01BF.epilog preserve=yes
//## end module%3A7EC53B01BF.epilog


#endif
